unit Question2_U;
// ---  Delphi and Database programming  ---
//
// Possible solution for Question 2.
// -----------------------------------------

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ConnectDB_U, DB, ADODB, Grids,
  DBGrids, ComCtrls, DateUtils, DBCtrls;

type
  TfrmDBQuestion2 = class(TForm)
    pnlBtns: TPanel;
    bmbClose: TBitBtn;
    bmbRestoreDB: TBitBtn;
    grpTblOrders: TGroupBox;
    grpTblPlants: TGroupBox;
    dbgPlants: TDBGrid;
    dbgOrders: TDBGrid;
    tabsQ2_2ADO: TTabSheet;
    tabsQ2_1SQL: TTabSheet;
    redDisplay: TRichEdit;
    grpResults: TGroupBox;
    dbgrdSQL: TDBGrid;
    grpOutput: TGroupBox;
    pgcTabs: TPageControl;
    pnlTables: TPanel;
    btnQ2_1_1: TButton;
    btnQ2_1_3: TButton;
    btnQ2_1_2: TButton;
    btnQ2_1_4: TButton;
    btnQ2_2_1: TButton;
    btnQ2_2_2: TButton;
    GroupBox1: TGroupBox;
    cmbPlantCode: TComboBox;
    Label1: TLabel;
    Category: TLabel;
    cmbCategory: TComboBox;
    Label2: TLabel;
    edtNumPlants: TEdit;
    btnQ2_1_5: TButton;
    procedure bmbRestoreDBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnQ2_1_1Click(Sender: TObject);
    procedure btnQ2_1_3Click(Sender: TObject);
    procedure btnQ2_1_2Click(Sender: TObject);
    procedure btnQ2_1_4Click(Sender: TObject);
    procedure btnQ2_2_1Click(Sender: TObject);
    procedure btnQ2_2_2Click(Sender: TObject);
    procedure cmbCategoryChange(Sender: TObject);
    procedure btnQ2_1_5Click(Sender: TObject);

  private
  public
  end;

var
  frmDBQuestion2: TfrmDBQuestion2;
  dbCONN: TConnection;

  // --- Provided global variables to be used ---
  tblPlants, tblOrders: TADOTable;

  // To be used in Question 2.2.1 and 2.2.2
  iNumOrdered: integer;
  sPlantCode: String;

implementation

{$R *.dfm}
{$R+}

// Question 2.1 - SQL SECTION

// =====================================================
// Question 2.1.1
// =====================================================
procedure TfrmDBQuestion2.btnQ2_1_1Click(Sender: TObject);
var
  sSQL1: String;
begin
  // Question 2.1.1

  sSQL1 := '';

  // Provided code - do not change
  dbCONN.runSQL(sSQL1);
end;


// =====================================================
// Question 2.1.2
// =====================================================
procedure TfrmDBQuestion2.btnQ2_1_2Click(Sender: TObject);
var
  sSQL2: String;
begin
  // Question 2.1.2

  sSQL2 := '';

  // Provided code - do not change
  dbCONN.runSQL(sSQL2);
end;


// =====================================================
// Question 2.1.3
// =====================================================
procedure TfrmDBQuestion2.btnQ2_1_3Click(Sender: TObject);
var
  sSQL3: String;
begin
  // Question 2.1.3

  sSQL3 := '';

  // Provided code - do not change
  dbCONN.runSQL(sSQL3);
end;


// =====================================================
// Question 2.1.4
// =====================================================
procedure TfrmDBQuestion2.btnQ2_1_4Click(Sender: TObject);
var
  sSQL4: String;
begin
  // Question 2.1.4

  sSQL4 := '';

  // Provided code - do not change
  dbCONN.runSQL(sSQL4);
end;


// =====================================================
// Question 2.1.5
// =====================================================
procedure TfrmDBQuestion2.btnQ2_1_5Click(Sender: TObject);
var
  sSQL5, sItemNum : String;
begin
     sItemNum := InputBox('Input','Item number: ','');
  // Question 2.1.5

    sSQL5 := '';

  // Provided code - do not change
  dbCONN.executeSQL(sSQL5,dbgOrders);
end;


// Question 2.2 - Section with Delphi code

// =====================================================
// Question 2.2.1
// =====================================================
procedure TfrmDBQuestion2.btnQ2_2_1Click(Sender: TObject);
var
  cContinue : char;
begin
  // Provided code
  redDisplay.Clear;
  iNumOrdered := StrToInt(edtNumPlants.Text);
  sPlantCode := cmbPlantCode.Text;
  // ====================================================
  // Question 2.2.1

end;


// =====================================================
// Question 2.2.2
// =====================================================
procedure TfrmDBQuestion2.btnQ2_2_2Click(Sender: TObject);
begin
  // Question 2.2.2

end;


{$Region Connection}

// =========================================================
// Setup of database connections - DO NOT CHANGE!
// =========================================================
procedure TfrmDBQuestion2.bmbRestoreDBClick(Sender: TObject);
begin
  dbCONN.RestoreDatabase(dbgPlants, dbgOrders, dbgrdSQL);
  dbCONN.formatTables;
  redDisplay.Clear;
  tblPlants := dbCONN.tblOne;
  tblOrders := dbCONN.tblMany;
end;

procedure TfrmDBQuestion2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  dbCONN.dbDisconnect;
end;

procedure TfrmDBQuestion2.FormCreate(Sender: TObject);
begin
  CurrencyString := 'R';
  dbCONN := TConnection.Create;
  dbCONN.dbConnect;
  tblPlants := dbCONN.tblOne;
  tblOrders := dbCONN.tblMany;
  dbCONN.setupGrids(dbgPlants, dbgOrders, dbgrdSQL);
  dbCONN.formatTables;
  pgcTabs.ActivePageIndex := 0;
  // Formatting display
  redDisplay.Clear;
  btnQ2_2_2.Enabled := false;
end;

procedure TfrmDBQuestion2.cmbCategoryChange(Sender: TObject);
begin
  cmbPlantCode.Clear;
  dbCONN.fillCombo(cmbCategory.Text);
  while NOT tblPlants.Eof do
  begin
    cmbPlantCode.Items.Add(tblPlants['PlantCode']);
    tblPlants.Next;
  end;
  tblPlants.Filtered := false;
  tblPlants.First;
end;
// =====================================================

{$EndRegion}


end.
